var pressure_20ma = 10; // Давление (бар), соответствующее току 20 мА
var zero_pressure_current = 0.004; // Ток, соответствующий нулевому давлению, А

var deviceCells = {
  "Alarm": {
    type: "switch",
    value: false
  },
  "AlarmHot": {
    type: "switch",
    value: false
  },
  "AlarmCold": {
    type: "switch",
    value: false
  },
  "PressureCold": {
    type: "value",
    value: 0.0
  },
  "PressureHot": {
    type: "value",
    value: 0.0
  }
};

defineVirtualDevice("pressure_sensor", {
  title: "Датчик давления(Bar)",
  cells: deviceCells
});

function setPressure(current, type) {
  if (type !== "Hot" && type !== "Cold") {
    log("Некорректный тип давления: " + type);
    return;
  }

  if (current >= zero_pressure_current) {
    dev["pressure_sensor"]["Pressure" + type] = (current - zero_pressure_current) * pressure_20ma / (0.020 - zero_pressure_current);
    dev["pressure_sensor"]["Alarm" + type] = false;
  } else {
    dev["pressure_sensor"]["Alarm" + type] = true;
  }
}

function pressureInit() {
  setPressure(dev["wb-adc"]["EXT1_A2"], "Cold");
  setPressure(dev["wb-adc"]["EXT1_A1"], "Hot");
}

defineRule("set_pressureCold", {
  whenChanged: "wb-adc/EXT1_A2",
  then: function(newValue, devName, cellName) {
    setPressure(newValue, "Cold");
  }
});

defineRule("set_pressureHot", {
  whenChanged: "wb-adc/EXT1_A1",
  then: function(newValue, devName, cellName) {
    setPressure(newValue, "Hot");
  }
});
